uva 11258 String Partition (DP)

来源:互联网 发布:淘宝的分享有礼 编辑:程序博客网 时间:2024/06/05 03:13

uva 11258 String Partition

John was absurdly busy for preparing a programming contest recently. He wanted to create a ridiculously easy problem for the contest. His problem was not only easy, but also boring: Given a list of non-negative integers, what is the sum of them?

However, he made a very typical mistake when he wrote a program to generate the input data for his problem. He forgot to print out spaces to separate the list of integers. John quickly realized his mistake after looking at the generated input file because each line is simply a string of digits instead of a list of integers.

He then got a better idea to make his problem a little more interesting: There are many ways to split a string of digits into a list of non-zero-leading (0 itself is allowed) 32-bit signed integers. What is the maximum sum of the resultant integers if the string is split appropriately?

Input
The input begins with an integer N ( ≤ 500) which indicates the number of test cases followed. Each of the following test cases consists of a string of at most 200 digits.

Output
For each input, print out required answer in a single line.

Sample input
6
1234554321
5432112345
000
121212121212
2147483648
11111111111111111111111111111111111111111111111111111

Sample output
1234554321
543211239
0
2121212124
214748372
5555555666

题目大意:给出一串数字序列,要求切割该数列,使得切割出的序列组成的数字小于int类型的最大值(INT_MAX),且切出的数的和最大。

递推。 dp[i]代表前i个数的最优解。

#include <cstdio>#include <cstring>#include <algorithm>#include <cmath>#include <cstdlib>#include <limits.h>using namespace std;#define N 300typedef long long ll;ll dp[N];int len;char s[N];void DP() {    for (int i = 1; i <= len; i++) {        for (int j = 1; j <= 10; j++) {            if (j > i) break;               ll sum = 0;            for (int k = 0; k < j; k++) {                sum = sum * 10 + s[i - j + k] - '0';            }            if (sum >= 0 && sum < INT_MAX) {                if (dp[i] < dp[i - j] + sum) {                    dp[i] = dp[i - j] + sum;                }            } else break;        }    }}int main() {    int T;    scanf("%d%*c", &T);    while (T--) {        scanf("%s", s);        len = strlen(s);        memset(dp, 0, sizeof(dp));        DP();        printf("%lld\n", dp[len]);    }    return 0;}
0 0
原创粉丝点击